// MenuObject.h : Declaration of the CMenuObject

#ifndef __MENUOBJECT_H_
#define __MENUOBJECT_H_

#include "resource.h"       // main symbols
#include <asptlb.h>         // Active Server Pages Definitions
#include "../common/util_list.h"
#include "../common/util_safe.h"

/////////////////////////////////////////////////////////////////////////////
// CMenuObject

#define	CMENU_STRING	1
#define	CMENU_POPUP		2

class CMenuItem
{
public:
	CMenuItem()
	{
		m_bstrItem = NULL;
		m_uCommand = 0;
	}

	virtual ~CMenuItem()
	{
		if (IsValidString(m_bstrItem)) SysFreeString(m_bstrItem);
	}

	BSTR	m_bstrItem;
	UINT	m_uCommand;
};

class CMenu
{
public:
	CMenu()
	{
		m_hMenu = NULL;
	}

	virtual ~CMenu()
	{
		if (m_hMenu)
		{
			DestroyMenu(m_hMenu);
		}
		m_itemList.DeleteItems();
	}

	HMENU	m_hMenu;
	CArrayPtr<CMenuItem>	m_itemList;
};

class ATL_NO_VTABLE CMenuObject : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CMenuObject, &CLSID_MenuObject>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CMenuObject>,
	public IDispatchImpl<IMenuObject, &IID_IMenuObject, &LIBID_CORELib>
{
public:
	CMenuObject();
	virtual ~CMenuObject();

public:

DECLARE_REGISTRY_RESOURCEID(IDR_MENUOBJECT)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CMenuObject)
	COM_INTERFACE_ENTRY(IMenuObject)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(CMenuObject)
END_CONNECTION_POINT_MAP()


// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IMenuObject
public:
	STDMETHOD(get_CreateMenu)(/*[out, retval]*/ long *pVal);
	STDMETHOD(TrackPopupMenu)(long lMenu, long x, long y);
	STDMETHOD(AppendMenu)(long lMenu, short iType, long lParam, BSTR bstrItem);
	LRESULT WINAPI WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	static LRESULT WINAPI ProxyWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

	CArrayPtr<CMenu>	m_menuList;
	HWND	m_hWnd;
};

#endif //__MENUOBJECT_H_
