// $Id: ShortcutItem.cpp,v 1.3 2000/02/17 06:37:19 mian Exp $

#include "stdafx.h"
#include "Core.h"
#include "ShortcutItem.h"

/////////////////////////////////////////////////////////////////////////////
// CShortcutItem

STDMETHODIMP CShortcutItem::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IShortcutItem,
	};
	for (int i=0;i<sizeof(arr)/sizeof(arr[0]);i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

CShortcutItem::CShortcutItem()
{
	m_hWnd = NULL;
}

CShortcutItem::~CShortcutItem()
{
	if (IsWindow(m_hWnd))
	{
		DestroyWindow(m_hWnd);
	}
}

STDMETHODIMP CShortcutItem::get_m_hWnd(long *pVal)
{
	*pVal = (long)m_hWnd;

	return S_OK;
}

STDMETHODIMP CShortcutItem::put_m_hWnd(long newVal)
{
	m_hWnd = (HWND)newVal;

	return S_OK;
}


STDMETHODIMP CShortcutItem::Destroy()
{
	Release();
	
	return S_OK;
}

/*
	$Log: ShortcutItem.cpp,v $
	Revision 1.3  2000/02/17 06:37:19  mian
	
	Added ActiveXObject to core component (use to load ActiveX controls inside any Window)
	
	Revision 1.2  2000/02/17 06:04:14  mian
	
	Fixed LoadObjects() not loading some objects, more shortcut item stuff
	
	Revision 1.1  2000/02/17 05:02:39  mian
	
	Added shortcut item
	
*/
