// $Id: Ripple.cpp,v 1.6 2000/02/23 02:06:13 mian Exp $

#include "stdafx.h"
#include "DeskEfx.h"
#include "Ripple.h"

/////////////////////////////////////////////////////////////////////////////
// CRipple


BOOL CRipple::BufferImage(BSTR lpszPath)
{
	if (m_hImageDC) DeleteDC(m_hImageDC);
	if (m_hbmImage) DeleteObject(m_hbmImage);
	m_nWidth = 0;
	m_nHeight = 0;
	m_hbmImage = (HBITMAP)LoadImageFromFile(lpszPath);
	if (m_hbmImage)
	{
		m_hImageDC = CreateCompatibleDC(NULL);
		BITMAP bmInfo;
		GetObject(m_hbmImage, sizeof(bmInfo), &bmInfo);
		m_nWidth = bmInfo.bmWidth;
		m_nHeight = bmInfo.bmHeight;
		SelectObject(m_hImageDC, m_hbmImage);
	}

	return TRUE;
}

STDMETHODIMP CRipple::LoadImage(BSTR bstrPath)
{
	BufferImage(bstrPath);

	return S_OK;
}

STDMETHODIMP CRipple::get_ImageWidth(long *pVal)
{
	*pVal = m_nWidth;

	return S_OK;
}

STDMETHODIMP CRipple::get_ImageHeight(long *pVal)
{
	*pVal = m_nHeight;

	return S_OK;
}

STDMETHODIMP CRipple::AddRippleArea(long left, long top, long right, long bottom)
{
	if (left < right && top < bottom)
	{
		CRect *pRect = new CRect;

		if (IsValidWritePtr(pRect))
		{
			pRect->left = left;
			pRect->top = top;
			pRect->right = right;
			pRect->bottom = bottom;
			m_rectRipples.Add(pRect);
		}
	}

	return S_OK;
}

STDMETHODIMP CRipple::ClearRippleAreas()
{
	m_rectRipples.DeleteItems();

	return S_OK;
}

/*
	$Log: Ripple.cpp,v $
	Revision 1.6  2000/02/23 02:06:13  mian
	
	Added TIFF decoding the gutil
	Renamed Graphite Utility Library directory to gutil for easier access
	
	Revision 1.5  2000/02/22 09:54:37  mian
	
	Made deskefx use LoadFromFromFile to support more image types
	Started on PCX image decoder
	
	Revision 1.4  2000/02/21 05:56:19  mian
	
	Small optimization in ripple paint loop
	
	Revision 1.3  2000/02/21 05:31:44  mian
	
	Added support for unlimited user defined ripple areas
	
	Revision 1.2  2000/02/20 15:21:02  mian
	
	Added DeskEfx to the Graphite workspace, added IE HTML tests
	
*/
