// $Id: gutil32.h,v 1.8 2000/02/23 08:56:13 mian Exp $
#ifndef _GUTIL32_H
#define _GUTIL32_H

#if !defined(_GUTIL32_)
#define GUTIL32API
#else
#define GUTIL32API __declspec(dllexport)
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*
	Load an image from any of the supported filetypes and return a
	bitmap handle
*/
GUTIL32API
HANDLE
WINAPI
LoadImageFromFileW(WCHAR *);

#define LoadImageFromFile LoadImageFromFileW

/*
	Generate a region based on a user defined transparent color in a bitmap
*/
GUTIL32API
HRGN
WINAPI
BitmapToRegion(HBITMAP, COLORREF, COLORREF, int, int);

/*
	Execute items in the specified CSIDL_* folder
*/
GUTIL32API
void
WINAPI
ExecuteCSIDLFolderItems(int);

/*
	Execute items in the startup folder
*/
GUTIL32API
void
WINAPI
ExecuteStartupFolderItems();

/*
	Execute items in the registry run keys
*/
GUTIL32API
void
WINAPI
ExecuteStartupRegistryItems();

/*
	Get a Windows associated icon and return an icon handle
*/
GUTIL32API
HICON
WINAPI
LoadIconFromWindow(HWND, BOOL);

#ifdef __cplusplus
}
#endif  /* __cplusplus */

#endif /* !_GUTIL32_H */

/*
	$Log: gutil32.h,v $
	Revision 1.8  2000/02/23 08:56:13  mian
	
	Cosmetic fixes
	
	Revision 1.7  2000/02/23 08:54:07  mian
	
	Added ability to execute registry startup items
	
	Revision 1.6  2000/02/23 08:28:24  mian
	
	Added icon functions to gutil
	
	Revision 1.5  2000/02/22 04:44:09  mian
	
	Added ExecuteStartupFolderItems and ExecuteCSIDLFolderItems to gutil
	
	Revision 1.4  2000/02/22 02:19:53  mian
	
	Cosmetic fixes
	
	Revision 1.3  2000/02/22 02:09:51  mian
	
	Added BitmapToRegion function
	
	Revision 1.2  2000/02/22 01:24:57  mian
	
	Added JPEG/PNG loading routines
	
	Revision 1.1  2000/02/21 08:55:00  mian
	
	Added Graphite Utility Library to the project
	
*/