// ScriptHost.h: interface for the CScriptHost class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SCRIPTHOST_H__DF886C2F_9911_43D9_A1D0_6BC149927964__INCLUDED_)
#define AFX_SCRIPTHOST_H__DF886C2F_9911_43D9_A1D0_6BC149927964__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <activscp.h>

class CScriptHost :
	public IActiveScriptSite,
	public IActiveScriptSiteWindow
{
public:
	HRESULT AddItem(BSTR bstrItem);
	HRESULT Stop();
	HRESULT Run(BSTR bstrPath);
	HRESULT CreateEngine(REFCLSID clsid);
	CScriptHost();
	virtual ~CScriptHost();

// IUnknown
		virtual HRESULT STDMETHODCALLTYPE QueryInterface(
			/* [in] */ REFIID riid,
			/* [out] */ void **ppvObj);

		virtual ULONG STDMETHODCALLTYPE AddRef(void);

		virtual ULONG STDMETHODCALLTYPE Release(void);

// IActiveScriptSite
		virtual HRESULT STDMETHODCALLTYPE GetLCID( 
            /* [out] */ LCID __RPC_FAR *plcid);
        
        virtual HRESULT STDMETHODCALLTYPE GetItemInfo( 
            /* [in] */ LPCOLESTR pstrName,
            /* [in] */ DWORD dwReturnMask,
            /* [out] */ IUnknown __RPC_FAR *__RPC_FAR *ppiunkItem,
            /* [out] */ ITypeInfo __RPC_FAR *__RPC_FAR *ppti);
        
        virtual HRESULT STDMETHODCALLTYPE GetDocVersionString( 
            /* [out] */ BSTR __RPC_FAR *pbstrVersion);
        
        virtual HRESULT STDMETHODCALLTYPE OnScriptTerminate( 
            /* [in] */ const VARIANT __RPC_FAR *pvarResult,
            /* [in] */ const EXCEPINFO __RPC_FAR *pexcepinfo);
        
        virtual HRESULT STDMETHODCALLTYPE OnStateChange( 
            /* [in] */ SCRIPTSTATE ssScriptState);
        
        virtual HRESULT STDMETHODCALLTYPE OnScriptError( 
            /* [in] */ IActiveScriptError __RPC_FAR *pscripterror);
        
        virtual HRESULT STDMETHODCALLTYPE OnEnterScript(void);
        
        virtual HRESULT STDMETHODCALLTYPE OnLeaveScript(void);

// IActiveScriptSiteWindow

		virtual HRESULT STDMETHODCALLTYPE GetWindow( 
            /* [out] */ HWND __RPC_FAR *phwnd);
        
        virtual HRESULT STDMETHODCALLTYPE EnableModeless( 
            /* [in] */ BOOL fEnable);

private:
	int					m_refCount;
	IActiveScript*		m_scrEngine;
	IActiveScriptParse*	m_scrParse;
};

#endif // !defined(AFX_SCRIPTHOST_H__DF886C2F_9911_43D9_A1D0_6BC149927964__INCLUDED_)
